package db

import (
	"applet/app/db/model"
	"applet/app/utils/logx"
	"reflect"
	"xorm.io/xorm"
)

type AdminWithEnterpriseDb struct {
	Db *xorm.Engine `json:"db"`
}

func (adminWithEnterpriseDb *AdminWithEnterpriseDb) Set() { // set方法
	adminWithEnterpriseDb.Db = Db
}

func (adminWithEnterpriseDb *AdminWithEnterpriseDb) FindAdminWithEnterprise(id int) (*[]model.AdminWithEnterprise, error) {
	var m []model.AdminWithEnterprise
	if err := adminWithEnterpriseDb.Db.Where("adm_id =?", id).Find(&m); err != nil {
		return nil, logx.Error(err)
	}
	return &m, nil
}

func (adminWithEnterpriseDb *AdminWithEnterpriseDb) AdminDeleteBySessionForAdmId(session *xorm.Session, admId interface{}) (int64, error) {
	if reflect.TypeOf(admId).Kind() == reflect.Slice {
		return session.In("adm_id", admId).Delete(model.AdminWithEnterprise{})
	} else {
		return session.Where("adm_id = ?", admId).Delete(model.AdminWithEnterprise{})
	}
}

func (adminWithEnterpriseDb *AdminWithEnterpriseDb) GetAdminWithEnterpriseByWithEnterprise(id int) (m *model.AdminWithEnterprise, err error) {
	m = new(model.AdminWithEnterprise)
	has, err := adminWithEnterpriseDb.Db.Where("role_id =?", id).Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (adminWithEnterpriseDb *AdminWithEnterpriseDb) AdminWithEnterpriseDeleteForWithEnterpriseBySession(session *xorm.Session, roleId interface{}) (int64, error) {
	if reflect.TypeOf(roleId).Kind() == reflect.Slice {
		return session.In("role_id", roleId).Delete(model.AdminWithEnterprise{})
	} else {
		return session.Where("role_id = ?", roleId).Delete(model.AdminWithEnterprise{})
	}
}

func (adminWithEnterpriseDb *AdminWithEnterpriseDb) AdminWithEnterpriseDeleteBySession(session *xorm.Session, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return session.In("id", id).Delete(model.AdminWithEnterprise{})
	} else {
		return session.Where("adm_id = ?", id).Delete(model.AdminWithEnterprise{})
	}
}

func (adminWithEnterpriseDb *AdminWithEnterpriseDb) BatchAddAdminWithEnterpriseBySession(session *xorm.Session, mm []*model.AdminWithEnterprise) (int64, error) {
	affected, err := session.Insert(mm)
	if err != nil {
		return 0, err
	}
	return affected, nil
}
