package model

type NursingHomeWithSpec struct {
	Id                 int    `json:"id" xorm:"not null pk autoincr INT(11)"`
	EnterpriseId       int    `json:"enterprise_id" xorm:"not null comment('单位id') INT(11)"`
	IsOpenBreakfast    int    `json:"is_open_breakfast" xorm:"not null default 1 comment('是否开启早餐(1:开启 0:关闭)') TINYINT(1)"`
	IsOpenLunch        int    `json:"is_open_lunch" xorm:"default 1 comment('是否开启午餐(1:开启 0:关闭)') TINYINT(1)"`
	IsOpenDinner       int    `json:"is_open_dinner" xorm:"default 1 comment('是否开启晚餐(1:开启 0:关闭)') TINYINT(1)"`
	BreakfastUnitPrice string `json:"breakfast_unit_price" xorm:"not null default 0.00 comment('早餐-单价') DECIMAL(4,2)"`
	LunchUnitPrice     string `json:"lunch_unit_price" xorm:"not null default 0.00 comment('午餐-单价') DECIMAL(4,2)"`
	DinnerUnitPrice    string `json:"dinner_unit_price" xorm:"not null default 0.00 comment('晚餐-单价') DECIMAL(4,2)"`
	CreateAt           string `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
	UpdateAt           string `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
}
